(*
    SNU 4541.664A HW3
*)

structure Syn = 
struct

type 
    pgm = cmd
and
    cmd = Skip
        | VarAssign of id * exp // x := exp
        | DerefAssign of id * exp // *x := exp
        | Seq of cmd * cmd
        | If of bexp * cmd * cmd
        | While of bexp * cmd
and
    exp = ReadInt
        | Num of int
        | Var of id    // x
        | Deref of id  // *x
        | AddrOf of id // &x
        | Bnop of bnop * exp * exp // binary numerical op
        | Unop of unop * exp          // unary numerical op
and 
    bexp = Blop of blop * exp * exp // binary numerical op
         | Land of bexp * bexp
and
    id  = string
and 
    bnop = Add 
and 
    unop = UMinus
and
    blop = Eq | Lt 

end

